package com.muyu.rule.server;

import com.muyu.common.domain.DataValue;
import com.muyu.common.enums.DataType;
import com.muyu.rule.common.basic.BasicEngine;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Author：张承志
 * @Package：com.muyu.rule.server
 * @Project：cloud-etl-rule
 * @name：Main
 * @Date：2024/8/29 15:57
 */
public class Main {

 static  Map<String , BasicEngine<DataValue>> engineMap = new ConcurrentHashMap<>();

 static Map<String,BasicEngine<DataValue[]>> engineRowMap = new ConcurrentHashMap<>();

    static Map<String,BasicEngine<DataValue[][]>> engineDataSetMap = new ConcurrentHashMap<>();
    static {
        try {
            Class<?> aClass = Class.forName("com.muyu.rule.common.engine.ENGINE_VALUE_VFD1000_V1");
            Class<?> aClass2 = Class.forName("com.muyu.rule.common.engine.ENGINE_VALUE_VFD1000_V2");
            Class<?> aClass3 = Class.forName("com.muyu.rule.common.engine.ENGINE_ROW_HANG_R1");
            Class<?> aClass4 = Class.forName("com.muyu.rule.common.engine.ENGINE_DataSet_asdf_S1");
            try {
                engineMap.put("ENGINE_VALUE_VFD1000_V1", (BasicEngine<DataValue>) aClass.newInstance());
                engineMap.put("ENGINE_VALUE_VFD1000_V2", (BasicEngine<DataValue>) aClass2.newInstance());
                engineRowMap.put("ENGINE_ROW_HANG_R1",(BasicEngine<DataValue[]>) aClass3.newInstance());
                engineDataSetMap.put("ENGINE_DataSet_asdf_S1",(BasicEngine<DataValue[][]>) aClass4.newInstance());
            } catch (InstantiationException e) {
                throw new RuntimeException(e);
            } catch (IllegalAccessException e) {
                throw new RuntimeException(e);
            }
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }

    }

    public static void main(String[] args) {


//        System.out.println("字段规则测试:");
//        DataValue dataValue = DataValue.builder()
//                .type(DataType.valueOf("String"))
//                .label("姓名")
//                .key("name")
//                .value(null)
//                .build();
//
//        BasicEngine<DataValue> engineValue = engineMap.get("ENGINE_VALUE_VFD1000_V1");
//
//        engineValue.set(dataValue);
//
//        engineValue.execution();


        System.out.println("记录规则测试:");

//        System.out.println(string);
        DataValue[] dataValues = new DataValue[]{
                new DataValue("name","姓名",DataType.VARCHAR,"张三"),
                new DataValue("name","姓名",DataType.VARCHAR,"李四"),
                new DataValue("name","姓名",DataType.VARCHAR,"王五"),
                new DataValue("name","姓名",DataType.VARCHAR,"张三")
        };

        BasicEngine<DataValue[]> engineRowHangR1 = engineRowMap.get("ENGINE_ROW_HANG_R1");

        engineRowHangR1.set(dataValues);
        engineRowHangR1.execution();

//        System.out.println("数据集规则测试:");
//
//        DataValue[][] dataValuesSet = new DataValue[3][3];
//
//
//        BasicEngine<DataValue[][]> engineDataSetAsdfS1 = engineDataSetMap.get("ENGINE_DataSet_asdf_S1");
//
//        engineDataSetAsdfS1.set(dataValuesSet);
//
//        engineDataSetAsdfS1.execution();



    }















}


